<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoPlanoSaude extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrorg                  = Utils::getParamters()->getNrorg();
        $nrvinculom             = $this->getSolicitacao()->getNrvinculom();
        $dsobssolicitacao       = $this->getSolicitacao()->getDsobssolicitacao();
        $nrbeneficiom           = $itens['NRBENEFICIOM']        ?? null;
        $nrpessoa               = $itens['NRPESSOA']            ?? null;
        $idtpbeneficiario       = $itens['IDTPBENEFICIARIO']    ?? null;
        $dtinscbeneficiario     = isset($itens['DTINSCBENEFICIARIO']) ? DateUtil::getDataDeString(substr($itens['DTINSCBENEFICIARIO'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $observacao             = $this->getObservacaoComProtocolo($dsobssolicitacao);
        
        $result = Utils::getEntityManager()->getRepository(Repositories::VAB_BENEFICIARIO)->findBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculom,"nrpessoa" => $nrpessoa,"nrbeneficiom" => $nrbeneficiom));
        if($result)
            throw new \Exception("Beneficiário já cadastrado");

        $vabBeneficiario = Repositories::VAB_BENEFICIARIO;
        $beneficiario = new $vabBeneficiario;
        $beneficiario->setNrorg($nrorg);
        $beneficiario->setNrvinculom($nrvinculom);
        $beneficiario->setNrbeneficiom($nrbeneficiom);
        $beneficiario->setNrpessoa($nrpessoa);
        $beneficiario->setIdtpbeneficiario($idtpbeneficiario);
        $beneficiario->setDtinscbeneficiario($dtinscbeneficiario);
        $beneficiario->setQtbeneficio(1);
        $beneficiario->setDsobsbeneficiario($observacao);
        $beneficiario->setDtinclusao(DateUtil::getDataAtual(false));
        $beneficiario->setNrorginclusao(Utils::getParamters()->getNrorg());
        $beneficiario->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $beneficiario->setNrbeneficiario(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'VAB_BENEFICIARIO', 1, 12, true));
        Utils::getEntityManager()->persist($beneficiario);
        Utils::getEntityManager()->flush();
    }
    
    public function rejeitar() {}
}