<?php

namespace HCM\Geral\Repository;

use HCM\Geral\Repository\EsoDemonstrativoCustomRepository;
use Doctrine\ORM\EntityManager;

class EsoDemonstrativoCustomRepository {
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getDemonstrativoESocial($parameters, $filters) {
      $param = self::selectMovimentacoes(isset($parameters['DADOSVINCULO'])?$parameters['DADOSVINCULO']:'N');
      $groupby = $param[1];
      $select = $param[0];
      $orderby = $param[2];
      $generalWhere = self::getWhereFilters($filters);
    
      if(array_key_exists('NRTIPOHIERARQORG', $parameters)) {
          $tipohierarquia = $parameters['NRTIPOHIERARQORG'];
          $tipohierarquia = "AND (HIERARQUIAORG.NRTIPOHIERARQORG = $tipohierarquia OR HIERARQUIAORG.NRTIPOHIERARQORG IS NULL)";
      }else{
          $tipohierarquia =  "AND 1 = 2";
      }
    
      $eventos = null;
      
    
      //Montagem do filtro de escopo do calculo folha
        $whereCalc = " "; 
        if(empty($parameters['DTOCORRENCIA'][0])){
          //Não há datas de escopo, usando a competência
          $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA = TO_DATE('".$parameters['P_DTMESCOMPETENC']."', 'DD/MM/YYYY') ";
        } else if(empty($parameters['DTOCORRENCIA'][1])){
            //Data de inicio preenchida e data de fim vazia
            $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA >= TRUNC(ADD_MONTHS(TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY') , -1), 'MONTH') ";
        } else{
            //Todas as datas preenchidas
            $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TRUNC(ADD_MONTHS(TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY') , -1), 'MONTH') AND '".$parameters['DTOCORRENCIA'][1]."' ";
        }
    
      //Montagem do filtro de escopo do item de cálculo
      $whereItem = " ";
        if(array_key_exists('DTOCORRENCIA', $parameters)){
            if(!empty($parameters['DTOCORRENCIA'][0])){
              //Data de inicio vazia e data de fim preenchida
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA <= TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  ";
            }
             if(empty($parameters['DTOCORRENCIA'][1])){
              //Data de inicio preenchida e data de fim vazia
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA >= TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  ";
            }else{
              //Todas as datas preenchidas
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA BETWEEN TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  AND TO_DATE('".$parameters['DTOCORRENCIA'][1]."', 'DD/MM/YYYY') ";
            }
        }
    
        if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
          $condEstrutLegal = "AND INSTR ("."'". $parameters['NRESTRUTLEGAL']."'".", VINCULOH.NRESTRUTLEGAL) > 0";
        } else {
            $condEstrutLegal = "";
        }
        
        if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          $condEstrutGeren = "AND INSTR ("."'". $parameters['NRESTRUTGEREN']."'".", VINCULOH.NRESTRUTGEREN) > 0";
        } else {
        $condEstrutGeren = "";
        }
        
        if(array_key_exists('NREVENTOM', $parameters)){
          $condicaoEventos = "AND INSTR ("."'". $parameters['NREVENTOM']."'".", FPA_ITECALCFOLHA.NREVENTOM) > 0";
        }else {
          $condicaoEventos = ' ';
        }
        $sql = "
        ".$select." FROM FPA_CALCULOFOLHA
    
        JOIN FPA_ITECALCFOLHA
               ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
              AND FPA_ITECALCFOLHA.NRORG          = FPA_CALCULOFOLHA.NRORG
              $condicaoEventos
              $whereItem
        JOIN GPE_VINCULOM
            ON (GPE_VINCULOM.NRORG         = FPA_ITECALCFOLHA.NRORG
            AND GPE_VINCULOM.NRVINCULOM    = FPA_ITECALCFOLHA.NRVINCULOM)
        JOIN GPE_VINCULOH VINCULOH
            ON (GPE_VINCULOM.NRORG           = VINCULOH.NRORG
           AND  GPE_VINCULOM.NRVINCULOM      = VINCULOH.NRVINCULOM)
           AND  VINCULOH.DTMESCOMPETENC =
               (SELECT MAX(DTMESCOMPETENC)
                        FROM GPE_VINCULOH
                        WHERE NRORG              = VINCULOH.NRORG
                            AND NRVINCULOM       = VINCULOH.NRVINCULOM
                            AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        
        LEFT JOIN GPE_TIPOVINCULOM 
               ON GPE_TIPOVINCULOM.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
              AND GPE_TIPOVINCULOM.NRORG = :P_NRORG_PADRAO
        LEFT JOIN GPE_TIPOVINCULOH GVH
               ON GVH.NRTIPOVINCULOM = GPE_TIPOVINCULOM.NRTIPOVINCULOM
              AND GVH.NRORG = GPE_TIPOVINCULOM.NRORG
              AND GVH.DTMESCOMPETENC =
                   (SELECT MAX(DTMESCOMPETENC)
                      FROM GPE_TIPOVINCULOH 
                     WHERE NRORG           = GVH.NRORG
                       AND NRTIPOVINCULOM  = GVH.NRTIPOVINCULOM
                       AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))                    
        
        JOIN FPA_EVENTOM
            ON  (FPA_EVENTOM.NRORG        = FPA_ITECALCFOLHA.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
            AND (FPA_EVENTOM.NREVENTOM    = FPA_ITECALCFOLHA.NREVENTOM)
            
            
        JOIN FPA_EVENTOH EVENTOH
            ON  (FPA_EVENTOM.NRORG           = EVENTOH.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
            AND (FPA_EVENTOM.NREVENTOM       = EVENTOH.NREVENTOM
            AND EVENTOH.DTMESCOMPETENC   =
                (SELECT MAX(DTMESCOMPETENC)
                        FROM FPA_EVENTOH
                        WHERE NRORG             = EVENTOH.NRORG
                            AND NREVENTOM       = EVENTOH.NREVENTOM
                            AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
        
        JOIN FPA_TIPOMOVIMENT TM ON ( TM.NRORG = :P_NRORG OR TM.NRORG = :P_NRORG_PADRAO ) 
                                     AND TM.NRTIPOMOVIMENT = FPA_CALCULOFOLHA.NRTIPOMOVIMENT
                                     AND TM.NRTIPOMOVIMENT IN (1,2,4,10,19,22)
                            
        /*Natureza da Rubrica*/
        JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EVENTOH.NRNATURUBR
        /*CONTRIBUICAO PREVIDENCIARIA NOVO*/
        LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                   FROM FPA_INCIDEVENTO IE
                   JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                   JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                  WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                          FROM FPA_GRPITEM 
                                         WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                  GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                 ) CP ON CP.NREVENTOM = FPA_EVENTOM.NREVENTOM
                     AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
        /*IRRF NOVO*/
        LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                   FROM FPA_INCIDEVENTO IE
                   JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                   JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                  WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                          FROM FPA_GRPITEM 
                                         WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                  GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                 ) IRRF ON IRRF.NREVENTOM = FPA_EVENTOM.NREVENTOM
                    AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
        /*FGTS NOVO*/
        LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                   FROM FPA_INCIDEVENTO IE
                   JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                   JOIN INCIDENCIAFGTS INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                  WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                          FROM FPA_GRPITEM 
                                         WHERE NRGRPINCIDE = 48) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                  GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                 ) FGTS ON FGTS.NREVENTOM = FPA_EVENTOM.NREVENTOM
                    AND INSTR(','||FGTS.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
        /*CONTRIBUICAO SINDICAL NOVO*/
        LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                    FROM FPA_INCIDEVENTO IE
                    JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                    JOIN INCIDENCIASIND INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                          FROM FPA_GRPITEM 
                                         WHERE NRGRPINCIDE = 49) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                    GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                    ) SIND ON SIND.NREVENTOM = FPA_EVENTOM.NREVENTOM
                    AND INSTR(','||SIND.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
            
        LEFT JOIN ESTRUTURAM ESTRUTLEGALM
            ON (VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
           AND  VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTLEGALH
            ON (ESTRUTLEGALM.NRORG        = ESTRUTLEGALH.NRORG
           AND  ESTRUTLEGALM.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
        AND  ESTRUTLEGALH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTLEGALH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTLEGALH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
        LEFT JOIN ESTRUTURAM ESTRUTGERENCM
            ON (VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
           AND  VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTGERENCH
            ON (ESTRUTGERENCM.NRORG        = ESTRUTGERENCH.NRORG
           AND  ESTRUTGERENCM.NRESTRUTURAM = ESTRUTGERENCH.NRESTRUTURAM)
        AND  ESTRUTGERENCH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTGERENCH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTGERENCH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        LEFT JOIN ESTRUTURAM ESTRUTSINDM
            ON (VINCULOH.NRORG         = ESTRUTSINDM.NRORG
           AND  VINCULOH.NRESTRUTSIND  = ESTRUTSINDM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTSINDH
            ON (ESTRUTSINDM.NRORG        = ESTRUTSINDH.NRORG
           AND  ESTRUTSINDM.NRESTRUTURAM = ESTRUTSINDH.NRESTRUTURAM)
        AND  ESTRUTSINDH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSINDH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSINDH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        JOIN GPE_PESSOA
            ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG
    
        JOIN GPE_PESSOAH
            ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
           AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                               FROM GPE_PESSOAH MAX_PESSOAH
                                              WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                                AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))                                                     
                        
        
        WHERE FPA_CALCULOFOLHA.NRORG          = :P_NRORG
          AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = :P_TPMODALIDCAL
          AND FPA_CALCULOFOLHA.NROCORRECAL    = :P_OCORRECAL
          $whereCalc
          $condEstrutLegal
          $condEstrutGeren
          $generalWhere
          $groupby
          $orderby";
          
        $query = $this->entityManager->getConnection()->prepare($sql);
            
        $query->execute(
        array(
            "P_DTMESCOMPETENC"  => $parameters['P_DTMESCOMPETENC'],
            "P_NRORG"           => $parameters['P_NRORG'],
            "P_TPMODALIDCAL"    => $parameters['NRTPMODALIDCAL'],
            "P_OCORRECAL"       => $parameters['NROCORRECAL'],
            "P_NRORG_PADRAO"    => $parameters['P_NRORG_PADRAO'],
        )
      );

      return $query->fetchAll();
    }

    public function selectMovimentacoes($filtroVinculo){
     
        $select = "SELECT VINCULOH.NRESTRUTLEGAL,
               ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,

               VINCULOH.NRESTRUTGEREN,
               ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,

               VINCULOH.NRESTRUTSIND,
               ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,

               FPA_CALCULOFOLHA.NRTIPOMOVIMENT,
               TM.NMTIPOMOVIMENT,
               FPA_ITECALCFOLHA.NRITEMCALCFOLHA,
               FPA_ITECALCFOLHA.NRCALCULOFOLHA,

               FPA_ITECALCFOLHA.NRVINCULOM,
               GPE_VINCULOM.NMVINCULOM,

               FPA_ITECALCFOLHA.NREVENTOM,
               EVENTOH.NMEVENTOH,
               FPA_ITECALCFOLHA.NRORG,
               FPA_ITECALCFOLHA.IDEVENDEMONCALC,
               FPA_ITECALCFOLHA.VRREFFOLHA,
               FPA_ITECALCFOLHA.VREVENTOFOLHA,
               SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA, 1, 10) DTOCORRENCIA,
               EVENTOH.NREVENTOH,
               FPA_EVENTOM.IDTIPOEVENTO,
               GPE_VINCULOM.NRTIPOVINCULOM,
               GVH.NMTIPOVINCULOH,
               GPE_PESSOAH.NRCPFPESSOA,
               
               GPE_VINCULOM.DTADMISSAOVINC,
               SUBSTR(GPE_VINCULOM.DTRESCISAOVINC, 1, 10) DTRESCISAOVINC,
               
               TM.NRTIPOMOVIMENT NRTABELA,
               FPA_EVENTOM.NREVENTOM CODRUBR,
               FPA_CALCULOFOLHA.NRTIPOMOVIMENT IDETABRUBR,
               EVENTOH.NMEVENTOH DSCRUBR,
               NR.CDESOCIAL NATRUBR,
               NR.NMNATURUBR NMNATRUBR,
               /*1 - Vencimento, provento ou pensao; 2 - Desconto; 3 - Informativa; 4 - Informativa dedutora.*/
               CASE
                 WHEN FPA_EVENTOM.NREVENTOM IN (1015) AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT <> 10 THEN '3'
                 WHEN FPA_EVENTOM.NREVENTOM IN (1290) AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1 THEN '4'
                 WHEN FPA_EVENTOM.NREVENTOM IN (1310, 1510, 1520) AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1 THEN '2'
                 ELSE DECODE(EVENTOH.IDEVENTODEMONST,'S','3',DECODE(FPA_EVENTOM.IDTIPOEVENTO,'PROVENTO','1','DESCONTO','2','ENCARGO','3','TOTAL','3'))
               END TPRUBR,
               NVL(CP.CDESOCIAL,'00') CODINCCP,
               NVL(IRRF.CDESOCIAL,'00') CODINCIRRF,
               NVL(FGTS.CDESOCIAL,'00') CODINCFGTS,
               NVL(SIND.CDESOCIAL,'00') CODINCSIND";

        $groupby = "";
        $orderby = "ORDER BY GPE_VINCULOM.NMVINCULOM, EVENTOH.NREVENTOM ASC";
        

        return array($select, $groupby, $orderby);
    }
      
    public function getWhereFilters($filters) {
        $whereFilter = " ";
        foreach ($filters as $filter) {
            if($filter['columnName']=='NRESTRUTLEGAL')
            $whereFilter .= " AND VINCULOH.NRESTRUTLEGAL = ".$filter['value']." ";
            if($filter['columnName']=='NRESTRUTGEREN')
            $whereFilter .= " AND VINCULOH.NRESTRUTGEREN = ".$filter['value']." ";
            if($filter['columnName']=='NRESTRUTSIND')
            $whereFilter .= " AND VINCULOH.NRESTRUTSIND = ".$filter['value']." ";
            else if($filter['columnName']=='NRVINCULOM')
            $whereFilter .= " AND FPA_ITECALCFOLHA.NRVINCULOM = '".$filter['value']."' ";
            else if($filter['columnName']=='NRTIPOVINCULOM')
            $whereFilter .= " AND GPE_VINCULOM.NRTIPOVINCULOM = '".$filter['value']."' ";
            else if($filter['columnName']=='NRTIPOMOVIMENT')
            $whereFilter .= " AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = '".$filter['value']."' ";
            else if($filter['columnName']=='IDTIPOEVENTO')
            $whereFilter .= " AND FPA_EVENTOM.IDTIPOEVENTO = '".$filter['value']."' ";
            else if($filter['columnName']=='IDEVENDEMONCALC')
            $whereFilter .= " AND FPA_ITECALCFOLHA.IDEVENDEMONCALC = '".$filter['value']."' ";
            else if($filter['columnName']=='NMEVENTOH'){
                $nmeventos = "";
                foreach ($filter['value'] as $nmevento) {
                    if($nmeventos == "")
                        $nmeventos .= "'".$nmevento."'";
                    else
                        $nmeventos .= ", '".$nmevento."'";
                        
                }              
                $whereFilter .= " AND EVENTOH.NMEVENTOH IN (".$nmeventos.") ";
            }
        }
        return $whereFilter;
        
    }
    
}