<?php
namespace HCM\Util\ModeloImportacao;

class BasicEntity 
{
	private $tableName;
	private $fields;
	private $columnNames;
    private $pk;

	public function __construct($tableName) 
	{
		$this->tableName = $tableName;
		$this->fields    = array();
		$this->columnNames      = array();
	}

	public function getTableName() 
	{
		return $this->tableName;
	}

	public function getFields()
	{
		return $this->fields;
	}

	public function addField($field, $value) 
	{
		$this->fields[strtoupper($field)] = $value;
		if (!in_array($field, $this->columnNames)) {
			$this->columnNames[] = trim(strtoupper($field));
		}
	}

	public function getField($field) 
	{
		$result = null;
		if (isset($this->fields[$field])) {
			$result = $this->fields[$field];
		}

		return $result;
	}

	public function hasColumn($columnName)
	{
		$columnName = str_replace("#", "", $columnName);
		return in_array($columnName, $this->getColumnNames());
	}

	public function getColumnNames() 
	{
		return $this->columnNames;
	}

    /**
     * @return mixed
     */
    public function getPk()
    {
        return $this->pk;
    }

    /**
     * @param mixed $pk
     */
    public function setPk($pk)
    {
        $this->pk = $pk;
    }
}