<?php

namespace HCM\Util;

class TkCode
{
    private $code;
    private $php_code;
    private $i;
    private $last_i;
    private $actual_char;

    function __construct($code)
    {
        $this->code = $code;
        $this->last_i = strlen($code) - 1;
    }

    function getAsPHP(array $var_names)
    {
        $this->php_code = '';
        $this->i = 0;
        $this->actual_char = $this->code[0];

        while (true)
        {
            $this->gotoNextName();
            $name = $this->getName();
            if (in_array($name, $var_names))
            {
                $this->php_code .= "\$$name";
            }
            else if ($name != "")
            {
                $this->php_code .= $name;
            }
            else
            {
                return $this->php_code . ';';
            }
        }
    }

    private function gotoNextName()
    {
        while (! $this->end())
        {
            if (ctype_alpha($this->actual_char)) break;
            $this->php_code .= $this->actual_char;
            if ($this->actual_char == "'" || $this->actual_char == '"') $this->skipString();
            $this->next();
        }
    }

    private function skipString() {
        $string_char = $this->actual_char;

        while (! $this->end()) {
            $this->next();
            $this->php_code .= $this->actual_char;
            if ($this->actual_char == $string_char && $this->code[$this->i - 1] != "\\") {
                break;
            }
        }
    }

    private function getName()
    {
        $name = "";

        while (! $this->end())
        {
            if (ctype_alnum($this->actual_char) || $this->actual_char == '_')
            {
                $name .= $this->actual_char;
                $this->next();
            }
            else break;
        }

        return $name;
    }

    private function next()
    {
        $this->i++;
        if ($this->i > $this->last_i) $this->actual_char = "END";
        else $this->actual_char = $this->code[$this->i];
    }

    private function end()
    {
        return $this->actual_char == "END";
    }
}