create or replace PROCEDURE ATUALIZA_LOCALESTOQ_PDR
(
P_CDFILIAL FILIAL.CDFILIAL%TYPE,
P_CDALMOXARIFE ALMOXARIFADO.CDALMOXARIFE%TYPE,
P_CDLOCALESTOQ LOCALESTOQUE.CDLOCALESTOQ%TYPE
)
AS
   V_UPDATE_TEXT  VARCHAR2(10000);
   V_INSERT_TEXT  VARCHAR2(10000);
   V_CDFILIAL_PADRAO FILIAL.CDFILIAL%TYPE;
   V_CDFILIAL_ATUAL_ALMOX    FILIAL.CDFILIAL%TYPE;
BEGIN
   
   SELECT CDFILIPADRAO
     INTO V_CDFILIAL_PADRAO
    FROM PARAMGERAL; 

   IF V_CDFILIAL_PADRAO IS NOT NULL THEN 
      IF (P_CDALMOXARIFE IS NOT NULL) THEN
         IF (P_CDFILIAL IS NULL) THEN
            FOR C_DELETA_LOCAL IN (SELECT LE.CDFILIAL, LE.CDALMOXARIFE, LE.CDLOCALESTOQ
                                     FROM LOCALESTOQUE  LE, PARAMFILIPADR PF
                                    WHERE PF.IDTABPARAMFILI = 'S'
                                      AND PF.NMTABPARAMFILI = 'LOCALESTOQUE'
                                      AND PF.CDFILIAL = LE.CDFILIAL
                                      AND PF.CDFILIAL <> V_CDFILIAL_PADRAO
                                      AND LE.CDALMOXARIFE = P_CDALMOXARIFE
                                      AND LE.CDLOCALESTOQ = NVL(P_CDLOCALESTOQ,LE.CDLOCALESTOQ)) LOOP
            /*TENTA DELETAR TODOS OS LOCAIS DA FILIAL, SE HOUVER REFERENCIAS OS
              REGISTROS PERMANECERO*/
               BEGIN 
                  DELETE FROM LOCALESTOQUE PF
                  WHERE CDFILIAL     = C_DELETA_LOCAL.CDFILIAL
                    AND CDALMOXARIFE = C_DELETA_LOCAL.CDALMOXARIFE
                    AND CDLOCALESTOQ = C_DELETA_LOCAL.CDLOCALESTOQ;
               EXCEPTION
                  WHEN OTHERS THEN
                     NULL;
               END;                                 
            END LOOP;
         END IF;   
      ELSE

      /*SELECIONA AS FILIAIS QUE SERO ALTERADAS
        PARA UTLIZAREM OS PARAMETROS DA FILIAL PADRAO*/
         FOR C_INSPARAM IN(SELECT CDFILIAL
                             FROM PARAMFILIPADR
                            WHERE IDTABPARAMFILI = 'S'
                              AND NMTABPARAMFILI = 'LOCALESTOQUE'
                              AND CDFILIAL <> V_CDFILIAL_PADRAO
                              AND CDFILIAL = NVL(P_CDFILIAL, CDFILIAL))LOOP
     
            V_UPDATE_TEXT := 'INSERT INTO LOCALESTOQUE (';
            V_INSERT_TEXT := '(SELECT ' ;
            /*SELECIONA OS CAMPOS DA TABELA 'LOCALESTOQUE'*/
            FOR C_CAMPO IN (SELECT COLUMN_NAME
                              FROM USER_TAB_COLUMNS
                             WHERE TABLE_NAME = 'LOCALESTOQUE') LOOP
      
               IF NOT (C_CAMPO.COLUMN_NAME = 'CDFILIAL') THEN
                  V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                  V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
               END IF;   

            END LOOP;
         
            BEGIN
               SELECT CDFILIAL
                 INTO V_CDFILIAL_ATUAL_ALMOX
                 FROM PARAMFILIPADR
                WHERE IDTABPARAMFILI = 'S'
                  AND NMTABPARAMFILI = 'ALMOXARIFADO'
                  AND CDFILIAL = C_INSPARAM.CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDFILIAL_ATUAL_ALMOX := NULL;
            END;
               /* SE UTILIZAR ATUALIZAO CHAMA A PROCEDURE DE ATUALIZAO
                 DOS PARAMETROS DA TABELA 'ALMOXARIFADO'*/   
            IF (V_CDFILIAL_ATUAL_ALMOX IS NOT NULL) THEN
                  ATUALIZA_ALMOXARIFADO_PDR(C_INSPARAM.CDFILIAL,NULL);
            END IF;
               
            V_UPDATE_TEXT := V_UPDATE_TEXT||'CDFILIAL) ';
            V_INSERT_TEXT := V_INSERT_TEXT||''''||C_INSPARAM.CDFILIAL||''''||' ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'FROM LOCALESTOQUE LE ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE CDFILIAL = '||''''||V_CDFILIAL_PADRAO||''''||' ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'AND NOT EXISTS (SELECT 1 FROM LOCALESTOQUE LO ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE LO.CDFILIAL   = '||''''||C_INSPARAM.CDFILIAL||''''||' ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'AND LO.CDALMOXARIFE = LE.CDALMOXARIFE ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'AND LO.CDLOCALESTOQ = LE.CDLOCALESTOQ ) ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'AND EXISTS (SELECT 1 FROM ALMOXARIFADO AL ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE CDFILIAL ='||''''||C_INSPARAM.CDFILIAL||''''||' ';
            V_INSERT_TEXT := V_INSERT_TEXT ||'AND AL.CDALMOXARIFE = LE.CDALMOXARIFE))';
            V_UPDATE_TEXT := V_UPDATE_TEXT || V_INSERT_TEXT;
            execute immediate V_UPDATE_TEXT ;                         
         END LOOP;
         COMMIT;
      END IF;   
   END IF;   
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_LOCALESTOQ_PDR','5.07.006'); END;
/
