create or replace PROCEDURE IMPORTA_RETORNO_SAGA
IS
   V_NROORD       VARCHAR2(40);
   V_NROITMORD    NUMBER;
   V_CODMER       VARCHAR2(20);
   V_VLRQTDMER    NUMBER;
   V_VLRQTDMERREA NUMBER;
   V_CDPRODUTO    VARCHAR2(10);
   V_CDMARCA      VARCHAR2(5);
   V_DTPROGENPEOL DATE;
   V_FLAPRC       VARCHAR2(5);
   --V_BOOLCOMMIT   BOOLEAN;
   V_CDFILDEST    VARCHAR2(4); 
   V_CDFILLANC    VARCHAR2(4);
   V_NRPEDEXOL    VARCHAR2(10);
   V_ERRONF       VARCHAR2(300);
   V_ERRO         VARCHAR2(300);
   --P_RETORNO  OUT VARCHAR2
   V_CDFILIOPELOG VARCHAR2(4);
   V_CDTIPOOPSAID VARCHAR2(2);
   V_CDTIPOOPENTR VARCHAR2(2);
   --V_CDFILIAL     VARCHAR2(4);
   
   V_LANCESTQOL   VARCHAR2(20);
   V_LANCESTQFI   VARCHAR2(20);
   
   V_LANCNFSAID   VARCHAR2(20);
   V_LANCNFENTR   VARCHAR2(20);
   V_PRXLANCTONF  VARCHAR2(20);
   V_PRXLANCESTQ  VARCHAR2(20);
   
   V_CDSERIE      VARCHAR2(5);
   V_CDEMPRESA    VARCHAR2(2);
   -- CONTROLE
   V_CONTROLE     VARCHAR2(40);
   V_TOTAL        FLOAT;
   V_CUSTTOTENTR  FLOAT;
   V_INSPRODNF    INTEGER;
   V_FILIAL       VARCHAR2(4);
   V_NRLANCTONF   VARCHAR2(10);
   V_DSPRODEMIS   VARCHAR2(400);
   V_CDTIPCUSTEST VARCHAR2(2);
   V_DTPROCESSA   DATE;
   V_BOFECHNOTA   BOOLEAN;
   V_BAIXA        VARCHAR2(1);
   V_NRSEQITPEOL  INTEGER;
   V_DESMER       VARCHAR2(300);
   V_QTDEESTO     FLOAT;
   V_VALRESTO     FLOAT;
   V_VALRBRUT     FLOAT;
   V_BAIXAPED     VARCHAR2(1);
   V_IDCTRSITMOR  FLOAT;
   V_CDPRUNEST    VARCHAR2(10);
   V_BOQUANTIDADE BOOLEAN;
   V_PRODUTO      VARCHAR2(10);
   V_VRFATORSKU   FLOAT;
   V_IDPRODMENSU  VARCHAR2(1);
   V_QTREALESTOQ  FLOAT;
   V_CDPRODREAL   VARCHAR2(10);
   V_VRFATCNVREAL FLOAT;
   V_QTATENDPEDOL FLOAT;
   V_QTPROGENPEOL FLOAT;
   V_QTATENDPEDOLV FLOAT;
   V_BOEXISTE     BOOLEAN;

   CURSOR C_INT_TRSITMORDENTSAI_OL/*(C_NROORD IN VARCHAR2)*/ IS
      SELECT NROORD, NROITMORD, CODMER, VLRQTDMER, VLRQTDMERREA, DESMER, IDCTRSITMORDENTSAI--, FLAPRC
        FROM INT_TRSITMORDENTSAI
       WHERE IDCTIPORD = 5
         AND NOT REGEXP_LIKE(NROORD, '\D')
         AND LENGTH(NROORD) = 19
         AND FLAPRC    = '0'
       ORDER BY NROORD;

   CURSOR C_ITEMPEDEXOL(C_CDFILDEST IN VARCHAR2, C_CDFILLANC IN VARCHAR2, C_NRPEDEXOL IN VARCHAR2, C_CODMER IN VARCHAR2) IS
      SELECT P.CDPRODESTO, I.CDMARCA, TO_CHAR(I.DTPROGENPEOL, 'DD/MM/YYYY') DTPROGENPEOL, I.CDPRODUTO, I.QTPROGENPEOL
        FROM ITEMPEDEXOL I, PRODUTO P, PRODUTO E
       WHERE I.CDPRODUTO  = E.CDPRODUTO
         AND E.CDPRODESTO = P.CDPRODESTO
         AND I.CDFILDEST  = C_CDFILDEST
         AND I.CDFILLANC  = C_CDFILLANC
         AND I.NRPEDEXOL  = C_NRPEDEXOL
         AND P.CDARVPROD  = C_CODMER;
   
   PROCEDURE RET_SERIE_EMPRESA(P_CDFILIAL IN VARCHAR2)
   IS
   BEGIN
      IF (P_CDFILIAL <> '9999') THEN
         SELECT S.CDSERIE, S.CDEMPRESA
           INTO V_CDSERIE, V_CDEMPRESA
           FROM SERIENF S, FILIAL F
          WHERE F.CDFILIAL   = P_CDFILIAL
            AND F.CDEMPRESA  = S.CDEMPRESA
            AND F.CDINSCESTA = S.CDINSCESTA
            AND F.CDINSCMUNI = S.CDINSCMUNI
            AND S.CDSERIE    = F.CDSERIE;
      ELSE
         V_CDSERIE := 'OL';
         
         SELECT CDEMPRESA
           INTO V_CDEMPRESA
           FROM FILIAL
          WHERE CDFILIAL = '9999';
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
         V_CDSERIE   := NULL;
         V_CDEMPRESA := NULL;
   END;

BEGIN
   V_PRXLANCTONF := NULL;
   V_PRXLANCESTQ := NULL;
   V_CONTROLE   := ' ';
   V_BOFECHNOTA := FALSE;
   V_ERRONF := NULL;

   V_ERRO := NULL;

   OPEN C_INT_TRSITMORDENTSAI_OL;--('1'||P_CDFILDEST||P_CDFILLANC||P_NRPEDEXOL);
   LOOP
      FETCH C_INT_TRSITMORDENTSAI_OL INTO V_NROORD, V_NROITMORD, V_CODMER, V_VLRQTDMER, V_VLRQTDMERREA, V_DESMER, V_IDCTRSITMOR;--, V_FLAPRC;

      IF (V_CONTROLE <> V_NROORD) OR (C_INT_TRSITMORDENTSAI_OL%NOTFOUND) THEN
         V_NRSEQITPEOL := 1;
         --V_BOEXISTE    := FALSE;
         IF (V_BOFECHNOTA) AND (V_ERRONF IS NULL) THEN
         -- FECHA NOTA FISCAL
            BEGIN
               /* FECHAMENTO DA NOTA DE SAIDA */
               GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => V_CDFILIOPELOG,
                                          P_NRLANCTONF => V_LANCNFSAID,
                                          P_DATAPROC   => TO_DATE(SYSDATE),
                                          P_NRLANCESTQ => V_LANCESTQOL,
                                          P_EVOLESTOQ  => 'S',
                                          P_IDATUESTOQ => 'N');

               ATUALIZA_ESTOQUE(P_FILIMOVI   => V_CDFILIOPELOG,
                                P_DTINICIAL  => TO_DATE(SYSDATE),
                                P_DTFINAL    => TO_DATE(SYSDATE),
                                P_FILILANCTO => V_CDFILIOPELOG,
                                P_NRLANCTO   => V_LANCESTQOL);

               /* FECHAMENTO DA NOTA DE ENTRADA */
--               GERA_FECHAMENTO_NFENTRADA(P_CDFILIAL   => V_CDFILDEST,
--                                         P_NRLANCTONF => V_LANCNFENTR,
--                                         P_DATAPROC   => TO_DATE(SYSDATE),
--                                         P_NRLANCESTQ => V_LANCESTQFI);

               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = '1',
                      DATULTPRC = SYSDATE
                WHERE NROORD = V_CONTROLE
                  AND FLAPRC <> '2';

               UPDATE PEDIDOEXOL
                  SET IDBAIXEXOL  = V_BAIXAPED,
                      IDBAIXEXSAI = V_BAIXAPED
                WHERE CDFILDEST   = V_CDFILDEST
                  AND CDFILLANC   = V_CDFILLANC
                  AND NRPEDEXOL   = V_NRPEDEXOL;

               V_ERRONF := NULL;   
               COMMIT;
            EXCEPTION
               WHEN OTHERS THEN
                  --ROLLBACK;
                  V_ERRONF := SQLERRM(SQLCODE);
                  UPDATE INT_TRSITMORDENTSAI
                     SET FLAPRC = '2',
                         DSCERR = V_ERRONF,
                         DATULTPRC = SYSDATE
                   WHERE NROORD = V_NROORD;
                  COMMIT;
            END;
         ELSE
            IF (V_ERRONF IS NOT NULL) THEN
               --ROLLBACK;
               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = '2',
                      DSCERR = 'Ocorreram erros durante a importao. Vide log',
                      DATULTPRC = SYSDATE
                WHERE NROORD = V_NROORD
                  AND DSCERR IS NULL;
               COMMIT;
            END IF;
            V_ERRONF := NULL;
         END IF;

         V_BOFECHNOTA := TRUE;
         V_CDFILDEST  := NULL;
         V_CDFILLANC  := NULL;
         V_NRPEDEXOL  := NULL;
         V_LANCNFSAID := NULL;
         V_LANCNFENTR := NULL;
         V_LANCESTQOL := NULL;
         V_CDFILIOPELOG := NULL;
         V_BAIXAPED     := '2';
      END IF;
      EXIT WHEN  C_INT_TRSITMORDENTSAI_OL%NOTFOUND;

      V_TOTAL := 0;
      IF V_CONTROLE <> V_NROORD THEN
         V_CONTROLE  := V_NROORD;
         V_CDFILDEST := SUBSTR(V_NROORD, 2, 4);
         V_CDFILLANC := SUBSTR(V_NROORD, 6, 4);
         V_NRPEDEXOL := SUBSTR(V_NROORD, -10);

         V_BOQUANTIDADE := TRUE;
         BEGIN
            SELECT CDFILIOPELOG
              INTO V_CDFILIOPELOG
              FROM PEDIDOEXOL
             WHERE CDFILDEST = V_CDFILDEST
               AND CDFILLANC = V_CDFILLANC
               AND NRPEDEXOL = V_NRPEDEXOL;
         EXCEPTION
            WHEN OTHERS THEN
               V_CDFILIOPELOG := NULL;
         END;

         --  boUtReserva
         /*BEGIN
            SELECT F.CDFILIAL
              INTO V_CDFILIAL
              FROM FILIAL F, PARASUPRI P
             WHERE P.IDUTRESPEDEXOL = 'S'
               AND P.IDUTILCONSSOLIOL = 'S'
               AND F.CDFILIAL = V_CDFILDEST
               AND NVL(F.CDFILCENTCMP, F.CDFILIAL) = P.CDFILIAL;
         EXCEPTION
            WHEN OTHERS THEN
               V_CDFILIAL := NULL;
         END;*/
         
         BEGIN
            SELECT CDTIPOOPERSAID, CDTIPOOPERENTR
              INTO V_CDTIPOOPSAID, V_CDTIPOOPENTR
              FROM TIPOOPEROPL
             WHERE CDFILIOPELOG = V_CDFILIOPELOG
               AND CDFILDEST    = V_CDFILDEST
               AND CDTIPOOPERSAID IS NOT NULL
               AND CDTIPOOPERENTR IS NOT NULL;
         EXCEPTION
            WHEN OTHERS THEN
               --ROLLBACK;
               V_CDTIPOOPSAID := NULL;
               V_CDTIPOOPENTR := NULL;
               V_ERRONF := 'Tipo de operao no relacionado entre as filiais '||V_CDFILIOPELOG||' e '||V_CDFILDEST;
               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = '2',
                      DSCERR = V_ERRONF,
                      DATULTPRC = SYSDATE
                WHERE NROORD = V_NROORD;
               --COMMIT;
         END;

         IF (V_CDTIPOOPSAID IS NOT NULL) THEN
            BEGIN
               --V_BOFECHNOTA := TRUE;
               /* NOTA FISCAL DE SAIDA DO OL */
               RET_SERIE_EMPRESA(V_CDFILDEST);

               NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIOPELOG, V_LANCNFSAID);
               NOVO_CODIGO_SC('LANCTOEST'||V_CDFILIOPELOG, V_LANCESTQOL);

               V_LANCNFSAID := SUBSTR(V_LANCNFSAID, -10);
               V_LANCESTQOL := SUBSTR(V_LANCESTQOL, -10);

               GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => V_CDFILIOPELOG,
                                     P_CDFILIEMIT  => V_CDFILIOPELOG,
                                     P_CDEMPRESA   => V_CDEMPRESA,
                                     P_CDTIPOOPER  => V_CDTIPOOPSAID,
                                     P_CDSERIE     => V_CDSERIE,
                                     P_CDCLIENTE   => V_CDFILDEST,
                                     P_DTENTRSAID  => TO_DATE(SYSDATE),
                                     P_IDSISTEMA   => 'DFS',
                                     P_ATUAESTOQUE => 'S',
                                     P_NRLANCTONF  => V_LANCNFSAID,
                                     P_IDPGTOFRETE => '9',
                                     P_NRLANCESTQ  => V_LANCESTQOL,
                                     P_PRXLANCTONF => V_PRXLANCTONF,
                                     P_PRXLANCESTQ => V_PRXLANCESTQ);

               /* NOTA FISCAL DE ENTRADA DA FILIAL */

               RET_SERIE_EMPRESA(V_CDFILDEST);

/*               NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILDEST, V_LANCNFENTR);
               NOVO_CODIGO_SC('LANCTOEST'||V_CDFILDEST, V_LANCESTQFI);

               V_LANCNFENTR := SUBSTR(V_LANCNFENTR, -10);
               V_LANCESTQFI := SUBSTR(V_LANCESTQFI, -10);

               GERA_NOTAFISCAL_CORPO_ENTRADA(P_CDFILIAL    => V_CDFILDEST,
                                             P_CDFILIRECE  => V_CDFILDEST,
                                             P_CDEMPRESA   => V_CDEMPRESA,
                                             P_CDTIPOOPER  => V_CDTIPOOPSAID,
                                             P_CDSERIEENTR => V_CDSERIE,
                                             P_CDCLIENTE   => V_CDFILIOPELOG,
                                             P_DTENTRSAID  => TO_DATE(SYSDATE),
                                             --P_DTEMISSAO   => TO_DATE(SYSDATE),
                                             P_IDSISTEMA   => 'DFE',
                                             P_ATUAESTOQUE => 'S',
                                             P_VRNOTAFISC  => 0, -- ATUALIZAR O VALOR DEPOIS?
                                             P_NRLANCTONF  => V_LANCNFENTR,
                                             P_NRLANCESTQ  => V_LANCESTQFI,
                                             P_PRXLANCTONF => V_PRXLANCTONF,
                                             P_PRXLANCESTQ => V_PRXLANCESTQ); */
            EXCEPTION
               WHEN OTHERS THEN
                  V_LANCNFSAID := NULL;
                  V_LANCNFENTR := NULL;
                  V_LANCESTQOL := NULL;
                  --ROLLBACK;
                  --V_BOFECHNOTA := FALSE;
                  V_ERRONF := SQLERRM(SQLCODE);
                  UPDATE INT_TRSITMORDENTSAI
                     SET FLAPRC = '2',
                         DSCERR = V_ERRONF,
                         DATULTPRC = SYSDATE
                   WHERE NROORD = V_NROORD;
                   --COMMIT;
            END;
         END IF;
      END IF;

      V_BOEXISTE := FALSE;
      IF (V_BOFECHNOTA) THEN
         OPEN C_ITEMPEDEXOL(V_CDFILDEST, V_CDFILLANC, V_NRPEDEXOL, V_CODMER);
         LOOP
            FETCH C_ITEMPEDEXOL INTO V_CDPRODUTO, V_CDMARCA, V_DTPROGENPEOL, V_CDPRODREAL, V_QTPROGENPEOL;

            IF (C_ITEMPEDEXOL%NOTFOUND) AND NOT(V_BOEXISTE) THEN
               --V_BOFECHNOTA := FALSE;
               V_ERRO := 'Produto '||V_CODMER||' retornou o valor zero e no encontramos nos itens do pedido.';
               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = '2',
                      DSCERR = V_ERRO,
                      DATULTPRC = SYSDATE
                WHERE NROORD = V_NROORD
                  AND CODMER = V_CODMER;

--                  V_LANCNFSAID := NULL;
--                  V_LANCNFENTR := NULL;
--                  V_LANCESTQOL := NULL;
            END IF;
            EXIT WHEN C_ITEMPEDEXOL%NOTFOUND;

            V_BOEXISTE := TRUE;

            IF (V_VLRQTDMERREA > 0) THEN
               BEGIN
                  SELECT D.CDPRUNEST
                    INTO V_CDPRUNEST
                    FROM CNVPRODUNEST C, RELACPRODOL R, CNVPRODUNEST D
                   WHERE (R.CDPRARVORIG  = V_CDPRODREAL)
                     AND (R.CDMARCA      = V_CDMARCA)
                     AND (R.CDPRODARVOL  = C.CDPRUNEST)
                     AND (C.CDPRODUTO    = D.CDPRODUTO);
               EXCEPTION
                  WHEN OTHERS THEN
                     V_CDPRUNEST := V_CDPRODUTO;
               END;

               IF (V_DESMER IS NULL) THEN
                  BEGIN
                     SELECT NMPRODUTO
                       INTO V_DSPRODEMIS
                       FROM PRODUTO
                      WHERE CDPRODUTO = V_CDPRODUTO;
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_DSPRODEMIS := NULL;
                  END;
               ELSE
                  V_DSPRODEMIS := V_DESMER;
               END IF;

               POSICAO_ESTOQUE(V_CDFILIOPELOG, V_CDPRUNEST, TO_DATE(SYSDATE), V_QTDEESTO, V_VALRESTO, V_VALRBRUT);

               IF (V_QTDEESTO = 0) THEN
                  --ROLLBACK;
                  --V_BOFECHNOTA := FALSE;
                  V_ERRO := 'Produto '||V_CODMER||' - '||V_DSPRODEMIS||' no possui quantidade em estoque logstico para movimentar';
                  UPDATE INT_TRSITMORDENTSAI
                     SET FLAPRC = '2',
                         DSCERR = V_ERRO,
                         DATULTPRC = SYSDATE
                   WHERE NROORD = V_NROORD
                     AND CODMER = V_CODMER;

--                  V_LANCNFSAID := NULL;
--                  V_LANCNFENTR := NULL;
--                  V_LANCESTQOL := NULL;
                  --COMMIT;
               END IF;
               --EXIT WHEN C_ITEMPEDEXOL%NOTFOUND; -- OR (V_ERRO IS NOT NULL)

               BEGIN
                  SELECT P.VRFATOCONV, NVL(C.IDPRODMENSU, 'N') IDPRODMENSU
                    INTO V_VRFATORSKU, V_IDPRODMENSU
                    FROM PRODUTO P, CARACPRODSAGA C
                   WHERE P.CDPRODESTO = V_CDPRODUTO
                     AND P.CDPRODUTO  = C.CDPRODUTO
                     AND C.IDUNIDPADRSAGA = 'S';
               EXCEPTION
                  WHEN OTHERS THEN
                     --ROLLBACK;
                     V_VRFATORSKU := 0;
                     --V_BOFECHNOTA := FALSE;
                     V_ERRO := 'Produto '||V_CODMER||' - '||V_DSPRODEMIS||' no possui unidade de medida padro cadastrado.';
                     UPDATE INT_TRSITMORDENTSAI
                        SET FLAPRC = '2',
                            DSCERR = V_ERRO,
                            DATULTPRC = SYSDATE
                      WHERE NROORD = V_NROORD
                        AND CODMER = V_CODMER;

--                     V_LANCNFSAID := NULL;
--                     V_LANCNFENTR := NULL;
--                     V_LANCESTQOL := NULL;

                     --COMMIT;
               END;

               IF ((V_VRFATORSKU > 0) AND (V_ERRO IS NULL)) THEN
                  IF (V_IDPRODMENSU = 'N') THEN
                     V_QTREALESTOQ := V_VLRQTDMERREA * V_VRFATORSKU;
                  ELSE
                     V_QTREALESTOQ := V_VLRQTDMERREA;
                  END IF;

                  V_BOQUANTIDADE := V_QTDEESTO >= V_QTREALESTOQ;
                  IF (V_BOQUANTIDADE) THEN

                     SELECT VRFATOCONV
                       INTO V_VRFATCNVREAL
                       FROM PRODUTO
                      WHERE CDPRODUTO = V_CDPRODREAL;

                     BEGIN
                        V_QTATENDPEDOLV := (V_VLRQTDMERREA*V_VRFATORSKU)/V_VRFATCNVREAL;
                     EXCEPTION
                        WHEN ZERO_DIVIDE THEN
                           V_QTATENDPEDOLV := 0;
                           V_ERRO := 'Fator de converso do produto igual a 0';
                           --V_BOFECHNOTA := FALSE;
                           UPDATE INT_TRSITMORDENTSAI
                            SET FLAPRC = '2',
                                DSCERR = V_ERRO,
                                DATULTPRC = SYSDATE
                          WHERE NROORD = V_NROORD
                            AND CODMER = V_CODMER;
--                           V_LANCNFSAID := NULL;
--                           V_LANCNFENTR := NULL;
  --                         V_LANCESTQOL := NULL;

                        WHEN OTHERS THEN
                           V_QTATENDPEDOLV := 0;
                           V_ERRO := SQLERRM(SQLCODE);
                           --V_BOFECHNOTA := FALSE;
                           UPDATE INT_TRSITMORDENTSAI
                            SET FLAPRC = '2',
                                DSCERR = V_ERRO,
                                DATULTPRC = SYSDATE
                          WHERE NROORD = V_NROORD
                            AND CODMER = V_CODMER;
--                           V_LANCNFSAID := NULL;
--                           V_LANCNFENTR := NULL;
--                           V_LANCESTQOL := NULL;
                     END;

                     IF (V_ERRO IS NULL) THEN

                        IF (V_QTATENDPEDOLV > 0) THEN
                           UPDATE ITEMPEDEXOL
                              SET QTATENDPEDOL = V_QTATENDPEDOLV
                            WHERE CDFILDEST    = V_CDFILDEST
                              AND CDFILLANC    = V_CDFILLANC
                              AND NRPEDEXOL    = V_NRPEDEXOL
                              AND CDPRODUTO    = V_CDPRODREAL
                              AND CDMARCA      = V_CDMARCA
                              AND DTPROGENPEOL = V_DTPROGENPEOL;

                           IF V_VLRQTDMERREA <> V_VLRQTDMER THEN
                              V_BAIXA := '1';
                           ELSE
                               V_BAIXA := '2';
                               V_BAIXAPED := V_BAIXA;
                           END IF;
                           /* OPERDOR TA FIXO.... VER MELHOR FORMA DE TRATAR ISSO */
                           INSERT INTO MOVALTITMPEXOL(CDFILDESTMOV, CDFILLANCMOV, NRPEDEXOLMOV, CDMARCAMOV, CDPRODANTESMOV, CDPRODAPOSMOV,
                                                      DTENRTANTESMOV, DTENRTAPOSMOV, QTPROGANTESMOV, QTPROGAPOSMOV, IDCONSIDERASOL,
                                                      IDATUALIZASOL, CDOPERADOR, DTOPERACAO)
                           VALUES(V_CDFILDEST, V_CDFILLANC, V_NRPEDEXOL, V_CDMARCA, V_CDPRODREAL, V_CDPRODREAL,
                                  V_DTPROGENPEOL, V_DTPROGENPEOL, V_QTPROGENPEOL, V_QTATENDPEDOLV, 'N',
                                  'N', '000000000119', SYSDATE);

                           UPDATE ITEMPEDEXOL
                              SET IDBAIXAOLSAI = V_BAIXA,
                                  IDBAIXENPEOL = V_BAIXA
                            WHERE CDFILDEST    = V_CDFILDEST
                              AND CDFILLANC    = V_CDFILLANC
                              AND NRPEDEXOL    = V_NRPEDEXOL
                              AND CDPRODUTO    = V_CDPRODUTO
                              AND CDMARCA      = V_CDMARCA
                              AND DTPROGENPEOL = V_DTPROGENPEOL;

                           /* ITENS DA NOTA */
                           V_FILIAL     := V_CDFILIOPELOG;
                           V_NRLANCTONF := V_LANCNFSAID;
--                           V_INSPRODNF  := 1;

                           SELECT NVL(P.CDTIPCUSTEST, 3) CDTIPCUSTEST, DECODE(PG.IDUTILDTPROC, 'S', NVL(P.DTPROCESSA, SYSDATE), SYSDATE) DTPROCESSA
                             INTO V_CDTIPCUSTEST, V_DTPROCESSA
                             FROM PARAMFILIAL P, PARAMGERAL PG
                            WHERE P.CDFILIAL    = V_FILIAL
                              AND PG.CDPARGERAL = '0001';
                           /* POSICAO DE ESTOQUE SAIDA */

                           /* CUSTO DO PRODUTO SERA O DO LANCAMENTO DE SAIDA */
                           V_CUSTTOTENTR := CUSTO_PRODUTO_LCEST(V_FILIAL, V_CDPRUNEST, V_CDTIPCUSTEST, TO_DATE(SYSDATE), V_DTPROCESSA, ' ', ' ', ' ', ' ');
                           /* QUANTIDADE A SER MOVIMENTADA */
                           IF (V_IDPRODMENSU = 'N') THEN
                              V_VLRQTDMERREA := V_VLRQTDMERREA*V_VRFATORSKU;
                           END IF;

                           BEGIN
                              --WHILE V_INSPRODNF <= 1 LOOP
                                /*SELECT DECODE(V_INSPRODNF, 0, V_CDPRUNEST, V_CDPRODUTO)
                                  INTO V_PRODUTO
                                  FROM DUAL;*/

                                V_PRODUTO := V_CDPRODUTO;

                                GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_FILIAL,
                                                        P_NRLANCTONF   => V_NRLANCTONF,
                                                        P_CDPRODUTO    => V_PRODUTO,
                                                        P_CDPRODEMIS   => V_CODMER,
                                                        P_DSPRODEMIS   => V_DSPRODEMIS,
                                                        P_QTITEMPROD   => V_VLRQTDMERREA,
                                                        P_VRUNITITEM   => V_CUSTTOTENTR,
                                                        P_IDATUESTPROD => 'S',
                                                        P_CDMARCA      => V_CDMARCA);

                                INSERT INTO NFRELACPEXOL(CDFILIAL, CDFILLANC, NRLANCTONF, CDFILDEST, NRPEDEXOL, CDPRODUTO, CDMARCA,
                                                         DTPROGENPEOL, QTNFRELPEXOL, VRNFRELPEXOL, NRSEQITPEOL)
                                VALUES(V_FILIAL, V_CDFILLANC, V_NRLANCTONF, V_CDFILDEST, V_NRPEDEXOL, V_CDPRODREAL, V_CDMARCA,
                                       V_DTPROGENPEOL, V_VLRQTDMERREA, V_CUSTTOTENTR, LPAD(V_NRSEQITPEOL, 4, '0'));

                             --   V_FILIAL     := V_CDFILDEST;
                             --   V_NRLANCTONF := V_LANCNFENTR;
--                                V_INSPRODNF  := V_INSPRODNF+1;
                              --END LOOP;

                              V_NRSEQITPEOL := V_NRSEQITPEOL+1;
                           EXCEPTION
                              WHEN OTHERS THEN
                                 --ROLLBACK;
                                 V_ERRO := SQLERRM(SQLCODE);
                                 --V_BOFECHNOTA := FALSE;
                                 UPDATE INT_TRSITMORDENTSAI
                                    SET FLAPRC = '2',
                                        DSCERR = V_ERRO,
                                        DATULTPRC = SYSDATE
                                  WHERE NROORD = V_NROORD
                                    AND CODMER = V_CODMER;
--                              V_LANCNFSAID := NULL;
--                              V_LANCNFENTR := NULL;
--                              V_LANCESTQOL := NULL;
                           END;
                        END IF;
                     END IF;
                  ELSE
                     V_ERRO := 'Produto '||V_CODMER||' - '||V_DSPRODEMIS||' indisponibilidade de estoque.';
                     --V_BOFECHNOTA := FALSE;
                     UPDATE INT_TRSITMORDENTSAI
                      SET FLAPRC = '2',
                          DSCERR = V_ERRO,
                          DATULTPRC = SYSDATE
                    WHERE NROORD = V_NROORD
                      AND CODMER = V_CODMER;

--                      V_LANCNFSAID := NULL;
--                      V_LANCNFENTR := NULL;
--                      V_LANCESTQOL := NULL;
                  END IF;
               END IF;
            ELSE
               DELETE ITEMPEDEXOL
                WHERE CDFILDEST    = V_CDFILDEST
                  AND CDFILLANC    = V_CDFILLANC
                  AND NRPEDEXOL    = V_NRPEDEXOL
                  AND CDPRODUTO    = V_CDPRODREAL
                  AND CDMARCA      = V_CDMARCA
                  AND DTPROGENPEOL = V_DTPROGENPEOL;

            END IF;
         END LOOP;

         CLOSE C_ITEMPEDEXOL;
      END IF;
      V_ERRO := NULL;
   END LOOP;

   COMMIT;
   CLOSE C_INT_TRSITMORDENTSAI_OL;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      V_ERRONF := SQLERRM(SQLCODE);
      UPDATE INT_TRSITMORDENTSAI
         SET FLAPRC = '2',
             DSCERR = V_ERRONF,
             DATULTPRC = SYSDATE
       WHERE NROORD = V_NROORD;

      COMMIT;
      
      CLOSE C_INT_TRSITMORDENTSAI_OL;
      IF C_ITEMPEDEXOL%ISOPEN THEN
         CLOSE C_ITEMPEDEXOL;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_RETORNO_SAGA','6.05.XXX'); END;
/